// src/jsx/utils.ts
var normalizeIntrinsicElementProps = (props) => {
  if (props && "className" in props) {
    props["class"] = props["className"];
    delete props["className"];
  }
};
var styleObjectForEach = (style, fn) => {
  for (const [k, v] of Object.entries(style)) {
    fn(
      k[0] === "-" ? k : k.replace(/[A-Z]/g, (m) => `-${m.toLowerCase()}`),
      v == null ? null : typeof v === "number" ? v + "px" : v
    );
  }
};
export {
  normalizeIntrinsicElementProps,
  styleObjectForEach
};
