import type { MiddlewareHandler } from '../../types';
/**
 * Trim the trailing slash from the URL if it does have one. For example, `/path/to/page/` will be redirected to `/path/to/page`.
 * @access public
 * @example app.use(trimTrailingSlash())
 */
export declare const trimTrailingSlash: () => MiddlewareHandler;
/**
 * Append a trailing slash to the URL if it doesn't have one. For example, `/path/to/page` will be redirected to `/path/to/page/`.
 * @access public
 * @example app.use(appendTrailingSlash())
 */
export declare const appendTrailingSlash: () => MiddlewareHandler;
